#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>

#define BUFSIZE 32

static void usage( void );
static int process_read( char** argv );
static int process_write( char** argv );


int 
main( int argc, char** argv )
{
	if ( argc == 2 && strcmp( argv[1], "read" ) == 0 ) {
		return process_read( argv );
	}
	else if ( argc == 3 && strcmp( argv[1], "write" ) == 0 ) {
		return process_write( argv );
	}

	usage();
	return 0;
}


static void
usage( void )
{
	printf( "Specify read / write as first option, \n" );
	printf( "   and text to write as second opeion when write mode.\n" );
}


static int 
process_read( char** argv )
{
	char rbuf[ BUFSIZE + 1 ];
	ssize_t len = 0;
	int fd;

	if ( ( fd = open( "/dev/chardev", O_RDONLY | O_NONBLOCK ) ) == -1 ) {
		perror( "open" );
		return -1;
	}

	while ( 1 ) {
		if ( ( len = read( fd, rbuf, BUFSIZE ) ) == -1 ) {
			perror( "read" );
			close( fd );
			return -1;
		}

		if ( len == 0 )
			break;

		rbuf[len] = '\0';

		printf( "%s", rbuf );
		fflush( stdout );
	} 

	close( fd );
	return 0;
}


static int
process_write( char** argv )
{
	int fd;

	if ( ( fd = open( "/dev/chardev", O_WRONLY| O_NONBLOCK ) ) == -1 ) {
		perror( "open" );
		return -1;
	}

	if ( write( fd, argv[2], strlen( argv[2] ) ) == -1 ) {
		perror( "write" );
		close( fd );
		return -1;
	}

	close( fd );
	return 0;
}


/* End of block_test.c */
