#include <fcntl.h>
#include <stdlib.h>
#include <sys/ioctl.h>

#include "chardev_ioctl.h"


int 
main( void )
{
	int  setval = 0;
	int  retval;
	int  fd;

	if ( ( fd = open( "/dev/chardev", O_RDWR ) ) < 0 ) {
		perror( "open" );
		exit( 1 );
	}


	/*
	 * IOCTL_TELL
	 */
	printf( "Tell driver to update internal value ...\n" );

	if ( ioctl( fd, CHARDEV_IOCTL_TELL, setval ) == -1 )
		perror( "ioctl( CHARDEV_IOCTL_TELL )" );


	/*
	 * IOCTL_QUERY
	 */
	printf( "Query driver internal value ...\n" );

	if ( ( retval = ioctl( fd, CHARDEV_IOCTL_QUERY ) ) == -1 )
		perror( "ioctl( CHARDEV_IOCTL_QUERY )" );

	printf( "Internal value = %d\n", retval );
	setval = retval + 1;


	/*
	 * IOCTL_SET
	 */
	printf( "Tell driver to update internal value via pointer ...\n" );

	if ( ioctl( fd, CHARDEV_IOCTL_SET, &setval ) == -1 )
		perror( "ioctl( CHARDEV_IOCTL_SET )" );


	/*
	 * IOCTL_GET
	 */
	printf( "Query driver internal value via pointer ...\n" );

	if ( ioctl( fd, CHARDEV_IOCTL_GET, &retval ) == -1 )
		perror( "ioctl( CHARDEV_IOCTL_GET )" );

	printf( "Internal value = %d\n", retval );


	/*
	 * IOCTL_RESET
	 */
	printf( "Reset reference counter ...\n" );

	if ( ioctl( fd, CHARDEV_IOCTL_RESET ) == -1 )
		perror( "ioctl( CHARDEV_IOCTL_RESET )" );


	close( fd );
	return 0;
}


/* End of ioctl_test.c */
