#include <asm/bitops.h>      /* test_and_set_bit, clear_bit */
#include <asm/io.h>          /* outb(), inb() */
#include <asm/system.h>      /* rmb() */
#include "hw_io.h"

static int lock;


/*
 * ߤλݡȤͤȻͤ or ̤
 * ݡȤ˽񤭹
 */
void
io_write_or( unsigned short port, unsigned int value )
{
	unsigned int data;
	
	if ( test_and_set_bit( 0, ( void* )( &lock ) ) != 0 )
		return;

	data  = inb( port );
	data |= value;
	outb( data, port );

	clear_bit( 0, ( void* )( &lock ) );
}


/*
 * ߤλݡȤͤȻͤ xor ̤
 * ݡȤ˽񤭹 ( ӥåȤȿž )
 */
void
io_write_xor( unsigned short port, unsigned int value )
{
	unsigned int data;

	if ( test_and_set_bit( 0, ( void* )( &lock ) ) != 0 )
		return;

	data  = inb( port );
	data ^= value;
	outb( data, port );

	clear_bit( 0, ( void* )( &lock ) );
}


/*
 * ͤݡȤ˽񤭹
 */
void
io_write_set( unsigned short port, unsigned int value )
{
	if ( test_and_set_bit( 0, ( void* )( &lock ) ) != 0 )
		return;

	outb( value, port );

	clear_bit( 0, ( void* )( &lock ) );
}


/*
 * ơݡȤͤɤ߹ߡACK ( 10 ֥ԥ )
 *  LOW ɤĴ٤롣
 */
int
io_is_button_pressed()
{
	unsigned int data;

	data = inb( IOPORT_STATUS );
	rmb();

	if ( ! ( data & ( 1 << STATUS_ACK ) ) )
		return 1;

	return 0;
}


/* End of hw_io.c */
